QT += winextras
# 设置输出根目录
ADS_OUT_ROOT = $${OUT_PWD}/..

# 设置生成类型为库，同时生成 DLL
TEMPLATE = lib
CONFIG += dll staticlib

# 设置输出目录为指定目录下的lib文件夹
DESTDIR = $${ADS_OUT_ROOT}/lib

# 设置包含路径为当前目录
INCLUDEPATH += $$PWD

# 设置生成的库文件名
TARGET = FramelessHelper

# 链接User32库
LIBS += -lUser32

HEADERS += \
    $$PWD/FramelessHelper.h \
    $$PWD/FramelessHelper_p.h \
    $$PWD/WindowFramelessHelper.h \
    $$PWD/WindowFramelessHelper_p.h
SOURCES += \
    $$PWD/FramelessHelper.cpp \
    $$PWD/WindowFramelessHelper.cpp

HEADERS += \
    $$PWD/Kernels/NativeWindowFilter.h \
    $$PWD/Kernels/NativeWindowFilter_p.h \
    $$PWD/Kernels/NativeWindowHelper.h \
    $$PWD/Kernels/NativeWindowHelper_p.h
SOURCES += \
    $$PWD/Kernels/NativeWindowFilter.cpp \
    $$PWD/Kernels/NativeWindowHelper.cpp
