﻿#include "GlobalDefinition.h"

#include <plugins/CA_GlobalDefinition/FunctionWidget.h>

#include <plugins/CA_GlobalDefinition/ParameterWidget.h>

#include <public/services/UiFrameService.h>

#include <utils/ServiceRegistry.h>

GlobalDefinition::GlobalDefinition()
{
    m_uiFrameService = ServiceRegistry<UiFrameService>::instance().getService();
    m_projectManagerService = ServiceRegistry<ProjectManagerService>::instance().getService();
    setupWidget(); 
}

void GlobalDefinition::setupWidget()
{
    m_functionWidget = new FunctionWidget;
    m_parameterWidget = new ParameterWidget;

}
