#ifndef GLOBALDEFINITION_H
#define GLOBALDEFINITION_H

#include <public/services/ProjectManagerService.h>
#include <public/services/UiFrameService.h>

#include <plugins/CA_Globaldefinition/FunctionWidget.h>
#include <plugins/CA_Globaldefinition/ParameterWidget.h>

class GlobalDefinition
{
public:
    GlobalDefinition();
private:
    void setupWidget();
private:
    UiFrameService *m_uiFrameService;
    ProjectManagerService *m_projectManagerService;
    FunctionWidget *m_functionWidget;
    ParameterWidget *m_parameterWidget;
};

#endif // GLOBALDEFINITION_H
