#include "CuboidSettingWidget.h"
#include "PreProcessing.h"
#include "ui_CuboidSettingWidget.h"

CuboidSettingWidget::CuboidSettingWidget(PreProcessing *preProcessing,QWidget *parent) :
    m_preProcessing(preProcessing),
    QWidget(parent),
    ui(new Ui::CuboidSettingWidget)
{
    ui->setupUi(this);
    ui->lineEdit->setText("5");
    ui->lineEdit_2->setText("5");
    ui->lineEdit_6->setText("5");

    ui->lineEdit_4->setText("0");
    ui->lineEdit_5->setText("0");
    ui->lineEdit_3->setText("0");
}

CuboidSettingWidget::~CuboidSettingWidget()
{
    delete ui;
}

void CuboidSettingWidget::on_startButton_clicked()
{
    int type = 0;
    if(ui->comboBox->currentText() == QStringLiteral("角")) type = 0;
     else  type = 1;
    m_preProcessing->generateCubiod(ui->lineEdit->text().toFloat(),ui->lineEdit_2->text().toFloat(),ui->lineEdit_6->text().toFloat(),
                                    ui->lineEdit_4->text().toFloat(),ui->lineEdit_5->text().toFloat(),ui->lineEdit_3->text().toFloat(),type);
}
