#pragma once

#include <vtkActor.h>

class readStl
{
public:
    readStl();
    ~readStl();
    
private:
    vtkSmartPointer<vtkActor> m_stl_actor;
    float m_color_x;
    float m_color_y;
    float m_color_z;
    float m_opacity;

public:
    vtkSmartPointer<vtkActor> getActor();
    void readStlFile(std::string file_name);
     
    //set but do not use,if need use,run void update() after set the value
    void setColor(float color_x, float color_y, float color_z);
    //set but do not use,if need use,run void update() after set the value
    void setOpacity(float opacity);
    
    float getOpacity()const{return m_opacity;}
    
    //update but do not set the value
    void update();
    //update but do not set the value
    void updateColor(float color_x, float color_y, float color_z);
    //update but do not set the value
    void updateOpacity(float opacity);
};
















