#pragma once

#include <vtkActor.h>

class readVtkWireframe
{
public:
    readVtkWireframe();
    ~readVtkWireframe();
    
private:
    vtkSmartPointer<vtkActor> m_vtk_actor;
    float m_color_x;
    float m_color_y;
    float m_color_z;
    float m_opacity;
    float m_line_width;

public:
    vtkSmartPointer<vtkActor> getActor();
    void readVtkFile(std::string file_name);
    
    //set but do not use,if need use,run void update() after set the value
    void setColor(float color_x, float color_y, float color_z);
    //set but do not use,if need use,run void update() after set the value
    void setOpacity(float opacity);
    //set but do not use,if need use,run void update() after set the value
    void setLineWidth(float line_width);
    
    float getOpacity()const{return m_opacity;}
    float getLineWidth()const{return m_line_width;}
    
    //update but do not set the value
    void update();
    //update but do not set the value
    void updateColor(float color_x, float color_y, float color_z);
    //update but do not set the value
    void updateOpacity(float opacity);
    //update but do not set the value
    void updateLineWidth(float line_width);
};
















