#pragma once

#include <vtkActor.h>

class readVtu
{
public:
    readVtu();
    ~readVtu();
    
private:
    vtkSmartPointer<vtkActor> m_vtu_actor;
    float m_color_x;
    float m_color_y;
    float m_color_z;
    float m_opacity;
    bool m_b_edge_on;

public:
    vtkSmartPointer<vtkActor> getActor();
    void readVtuFile(std::string file_name);
    
    //set but do not use,if need use,run void update() after set the value
    void setColor(float color_x, float color_y, float color_z);
    //set but do not use,if need use,run void update() after set the value
    void setOpacity(float opacity);
    //set but do not use,if need use,run void update() after set the value
    void setStatusEdge(bool b_edge_on);
    
    float getOpacity()const{return m_opacity;}
    bool getStatusEdge()const{return m_b_edge_on;}
      
    //update but do not set the value
    void update();
    //update but do not set the value
    void updateColor(float color_x, float color_y, float color_z);
    //update but do not set the value
    void updateOpacity(float opacity);
    //update but do not set the value
    void updateStatusEdge(bool b_edge_on);
};
















