#pragma once

#include <vtkActor.h>

class readVtuWireframe
{
public:
    readVtuWireframe();
    ~readVtuWireframe();
    
private:
    vtkSmartPointer<vtkActor> m_vtu_actor;
    float m_color_x;
    float m_color_y;
    float m_color_z;
    float m_opacity;
    float m_line_width;

public:
    vtkSmartPointer<vtkActor> getActor();
    //xml unstructreader,if not xml.please use readVtkWireframse
    void readVtuFile(std::string file_name); 
    
    //set but do not use,if need use,run void update() after set the value
    void setColor(float color_x, float color_y, float color_z);
    void setOpacity(float opacity);
    void setLineWidth(float line_width);
    
    float getOpacity()const{return m_opacity;}
    float getLineWidth()const{return m_line_width;}
    
    //update but do not set the value
    void update();
    //update but do not set the value
    void updateColor(float color_x, float color_y, float color_z);
    //update but do not set the value
    void updateOpacity(float opacity);
    //update but do not set the value
    void updateLineWidth(float line_width);
};
















