#pragma once

#include <QPushButton>
#include <QToolButton>
#include <QTreeWidgetItem>
#include <QWidget>

struct UiFrameService
{
    virtual void addWidget(QWidget *widget, QString name) = 0;

    virtual void setSettingWidget(QWidget *widget) = 0;

    virtual void addMenuButton(QString tabName, QString groupName, QToolButton *button) = 0;

    virtual void addFileButton(QPushButton *button) = 0;
};
