﻿#include "OutputWidget.h"
#include "ui_OutputWidget.h"

#include <public/services/UiFrameService.h>
#include <utils/ServiceRegistry.h>

OutputWidget::OutputWidget(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::OutputWidget)
{
    ui->setupUi(this);
    m_uiFrameService = ServiceRegistry<UiFrameService>::instance().getService();


    QWidget *temp= new QWidget;

    m_uiFrameService->addWidget(new QWidget,QStringLiteral("消息"));

    m_uiFrameService->addWidget(new QWidget,QStringLiteral("日志"));
    m_uiFrameService->addWidget(new QWidget,QStringLiteral("进度"));

    QPixmap pixmap(":/resources/outputWidgetBtn/btn_clear.png");
    ui->pushButton_4->setIcon(QIcon(pixmap));
    ui->pushButton_4->setIconSize(QSize(30, 30));
    ui->pushButton_4->setFixedSize(30, 30);
    ui->pushButton_4->setStyleSheet("background:white; border:none;");

    QPixmap pixmap2(":/resources/outputWidgetBtn/btn_emil.png");
    ui->pushButton_5->setIcon(QIcon(pixmap2));
    ui->pushButton_5->setIconSize(QSize(30, 30));
    ui->pushButton_5->setFixedSize(30, 30);
    ui->pushButton_5->setStyleSheet("background:white; border:none;");
}

OutputWidget::~OutputWidget()
{
    delete ui;
}
