#pragma once

#include<iostream>
#include<fstream>
#include<string>
#include<vector>

using namespace std;

class readCurveData
{
public:
    readCurveData();
    ~readCurveData();
    
private:
    vector<std::string> m_vec_data_name;
    //vector<int> vec_data_step;
    vector<vector<float>> m_vec_vec_data;
    vector<float> m_vec_max_data;
    vector<float> m_vec_min_data;
    int m_x_value_max;

private:    
    void removeLineCarriage(std::string *line);
    void split(const string &strtem, const char a, vector<string> &res);
       
public:
    bool readCurveDataFile(std::string curve_data_file_name);
    int getStepValueMax();
    int getStepUseValueMax();
    vector<float>& getMaxValue();
    vector<float>& getMinValue();
    vector<vector<float>>& getData();
    vector<std::string>& getDataName();
};
















