#ifndef PROJECTMANAGER_H
#define PROJECTMANAGER_H
#include <QObject>
#include <public/services/ProjectManagerService.h>

class ProjectManagerWidget;
class ProjectManager: public QObject, public ProjectManagerService
{
    Q_OBJECT
public:
    ProjectManager();

    void isDirty();
    void newProject();
    void openProject();
    void saveProject();
    void reSaveProject();
    void addTreeItem(QTreeWidgetItem *treeItem);
    void setItemWidget(QString uuid,QWidget *widget);
    void setCurrentItem(QTreeWidgetItem *item);
    void expandTreeWidget();
private:
    ProjectManagerWidget *m_projectManagerWidget;

};

#endif // PROJECTMANAGER_H
